# coding: utf-8
# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20181231


from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class ServiceCategories(object):
    """
    List of Service Categories of a Service for MOS Taxonomy.
    """

    def __init__(self, **kwargs):
        """
        Initializes a new ServiceCategories object with values from keyword arguments.
        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param service:
            The value to assign to the service property of this ServiceCategories.
        :type service: dict(str, str)

        :param schema:
            The value to assign to the schema property of this ServiceCategories.
        :type schema: str

        :param sub_categories:
            The value to assign to the sub_categories property of this ServiceCategories.
        :type sub_categories: list[oci.cims.models.SubCategories]

        """
        self.swagger_types = {
            'service': 'dict(str, str)',
            'schema': 'str',
            'sub_categories': 'list[SubCategories]'
        }

        self.attribute_map = {
            'service': 'service',
            'schema': 'schema',
            'sub_categories': 'subCategories'
        }

        self._service = None
        self._schema = None
        self._sub_categories = None

    @property
    def service(self):
        """
        Gets the service of this ServiceCategories.
        Service Category list.


        :return: The service of this ServiceCategories.
        :rtype: dict(str, str)
        """
        return self._service

    @service.setter
    def service(self, service):
        """
        Sets the service of this ServiceCategories.
        Service Category list.


        :param service: The service of this ServiceCategories.
        :type: dict(str, str)
        """
        self._service = service

    @property
    def schema(self):
        """
        Gets the schema of this ServiceCategories.
        Schema of a Service Category.


        :return: The schema of this ServiceCategories.
        :rtype: str
        """
        return self._schema

    @schema.setter
    def schema(self, schema):
        """
        Sets the schema of this ServiceCategories.
        Schema of a Service Category.


        :param schema: The schema of this ServiceCategories.
        :type: str
        """
        self._schema = schema

    @property
    def sub_categories(self):
        """
        Gets the sub_categories of this ServiceCategories.
        The service categories list for MOS Taxonomy.


        :return: The sub_categories of this ServiceCategories.
        :rtype: list[oci.cims.models.SubCategories]
        """
        return self._sub_categories

    @sub_categories.setter
    def sub_categories(self, sub_categories):
        """
        Sets the sub_categories of this ServiceCategories.
        The service categories list for MOS Taxonomy.


        :param sub_categories: The sub_categories of this ServiceCategories.
        :type: list[oci.cims.models.SubCategories]
        """
        self._sub_categories = sub_categories

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
